--    Copyright (C) 2004 by neuron                                          
--    aagaande@gmail.com                                            
--                                                                          
--    This program is free software; you can redistribute it and--or modify  
--    it under the terms of the GNU General Public License as published by  
--    the Free Software Foundation; either version 2 of the License, or     
--    (at your option) any later version.                                   
--                                                                          
--    This program is distributed in the hope that it will be useful,       
--    but WITHOUT ANY WARRANTY; without even the implied warranty of        
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         
--    GNU General Public License for more details.                          
--                                                                          
--    You should have received a copy of the GNU General Public License     
--    along with this program; if not, write to the                         
--    Free Software Foundation, Inc.,                                       
--    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 

local L = AceLibrary("AceLocale-2.2"):new("nQuestLog-Options")
L:RegisterTranslations("enUS", function() return {
	["Reset position of minion"] = true,
	["This is incase you lost it"] = true,

	["Reset Profile"] = true,
	["This will reset the current profile"] = true,

	["Minion Visible"] = true,
	["Note that minion will not show if your not tracking any quests."] = true,

	["Settings"] = true,
	["This needs work, I know"] = true,

	["Main settings"] = true,

	["Lock minion"] = true,
	["Lock the minion to avoid dragging (drag by pulling top left)"] = true,

	["Quest"] = true,
	["Show new quests"] = true,
	["Auto show new quests in minion"] = true,
	["Show quest when looting questitem"] = true,
	["Auto show hidden quests when you loot a quest item for it"] = true,

	["Quest objectives"] = true,
	["Hide All Objectives"] = true,
	["Hide all quest objectives by default"] = true,
	["Hide Completed Objectives"] = true,
	["Hide completed objectives"] = true,

	["Layouts"] = true,

	-- Layout stuff:
	["Minion layout"] = true,
	["Grow upwards"] = true,
	["Grow minion up"] = true,
	["Width"] = true,
	["Set width of frame"] = true,
	["Fontsize"] = true,
	["Change font size for minion"] = true,
	["Change font size for zone"] = true,

	--Zone Related:
	["Zone layout"] = true,
	["Show Visible/Total quests for a zone"] = true,
	["Shows <Zone> with X/X Visible"] = true,
	["Show empty zones"] = true,
	["Show hidden zones where you are not tracking any quests"] = true,
	["Show Zone level"] = true,
	["Show zone level"] = true,
	["Padding"] = true,
	["Change padding between zones"] = true,
		
	--Quest Related:
	["Quest layout"] = true,
	["Show Quest Progress"] = true,
	["Show quest progress (1/7 items total)"] = true,
	["Padding"] = true,
	["Change padding between quests"] = true,
		
	--Quest objectives related:
	["Quest objectives layout"] = true,
	["Show Description when no objectives"] = true,
	["Show small quest description when no progress is available"] = true,

} end)

L:RegisterTranslations("koKR", function() return {
	["Reset position of minion"] = "알림창 위치 초기화",
	["This is incase you lost it"] = "퀘스트 알림창을 가운데로 이동합니다. 드래그로 이동할 수 있습니다.",

	["Reset Profile"] = "프로파일 초기화",
	["This will reset the current profile"] = "현재 선택된 프로파일을 초기화합니다.",

	["Minion Visible"] = "퀘스트 알림창 표시",
	["Note that minion will not show if your not tracking any quests."] = "퀘스트를 받거나 퀘스트 진행이 없더라도 퀘스트 알림창을 보여줍니다.",

	["Settings"] = "설정",
	["This needs work, I know"] = "애드온 설정입니다.",

	["Main settings"] = "메인 설정",

	["Lock minion"] = "알림창 고정",
	["Lock the minion to avoid dragging (drag by pulling top left)"] = "알림창을 고정합니다.",

	["Quest"] = "퀘스트",
	["Show new quests"] = "새로운 퀘스트 보기",
	["Auto show new quests in minion"] = "새로운 퀘스트를 받으면 자동으로 알림창에 등록합니다.",
	["Show quest when looting questitem"] = "퀘스트 아이템 수집시 보기",
	["Auto show hidden quests when you loot a quest item for it"] = "퀘스트 아이템을 집었을 때 자동으로 퀘스트를 등록합니다.",

	["Quest objectives"] = "퀘스트 목표",
	["Hide All Objectives"] = "퀘스트 목표 숨기기",
	["Hide all quest objectives by default"] = "모든 퀘스트 목표를 숨깁니다.",
	["Hide Completed Objectives"] = "완료된 목표 숨기기",
	["Hide completed objectives"] = "퀘스트의 완료된 목표는 숨깁니다",

	["Layouts"] = "레이아웃",

	-- Layout stuff:
	["Minion layout"] = "알림창 레이아웃",
	["Grow upwards"] = "추가내용 위로 표시",
	["Grow minion up"] = "알림창에 추가되는 목표 및 퀘스트를 위로 표시합니다.",
	["Width"] = "길이",
	["Set width of frame"] = "프레임의 길이를 설정합니다.",
	["Fontsize"] = "글자 크기",
	["Change font size for minion"] = "알림창의 글자 크기를 설정합니다.",

	--Zone Related:
	["Zone layout"] = "지역 레이아웃",
	["Show Visible/Total quests for a zone"] = "진행중인 퀘스트 갯수 표시",
	["Shows <Zone> with X/X Visible"] = "각 지역의 '수행중/전체' 퀘스트의 갯수를 표시합니다.",
	["Show empty zones"] = "빈 지역 보기",
	["Show hidden zones where you are not tracking any quests"] = "퀘스트 상황이 숨겨진 지역도 표시합니다.",
	["Show Zone level"] = "지역 레벨 표시",
	["Show zone level"] = "퀘스트 수행 지역의 레벨을 표시합니다.",
	["Padding"] = "간격",
	["Change padding between zones"] = "퀘스트 수행 지역간 간격을 설정합니다.",
		
	--Quest Related:
	["Quest layout"] = "퀘스트 레이아웃",
	["Show Quest Progress"] = "퀘스트 진행상황 표시",
	["Show quest progress (1/7 items total)"] = " 퀘스트 진행 상황을 (1/7 아이템 획득) 형태로 표시합니다.",
	["Padding"] = "간격",
	["Change padding between quests"] = " 퀘스트사이의 간격을 설정합니다.",
		
	--Quest objectives related:
	["Quest objectives layout"] = "퀘스트 목표 레이아웃",
	["Show Description when no objectives"] = "목표 없는 퀘스트 설명표시",
	["Show small quest description when no progress is available"] = "퀘스트의 목표의 진행상황이 없는 경우 퀘스트 설명을 표시합니다.",

} end)

local options = {
		type='group',
		args = {
	         resetPos = {
	            type = 'execute',
	            name = L["Reset position of minion"],
	            desc = L["This is incase you lost it"],
	            func = function()
	            	nQuestLogFrame:ClearAllPoints()
	            	nQuestLogFrame:SetPoint("CENTER",0,0)
	            	nQuestLog:SavePosition()
	            	nQuestLog:SetPosition()
	            	nQuestLog.db.profile["trackerLocked"] = false
	            end
	        },
	         resetProfile = {
	            type = 'execute',
	            name = L["Reset Profile"],
	            desc = L["This will reset the current profile"],
	            order = 500,
	            func = function()
	            	nQuestLog:ResetDB("profile")
	            	nQuestLogFrame:ClearAllPoints()
	            	nQuestLogFrame:SetPoint("CENTER",0,0)
	            	nQuestLog:SavePosition()
	            	nQuestLog:SetPosition()
	            	nQuestLog:RefreshTracker()
	            end
	        },
	         toggleVisible = {
	            type = 'toggle',
	            name = L["Minion Visible"],
	            desc = L["Note that minion will not show if your not tracking any quests."],
	            get = function()
	            	return nQuestLog.db.char["visible"]
	            end,
	            set = function(v)
	            	nQuestLog.db.char["visible"] = v
	            	nQuestLog:ToggleVisible(v)
	            end
	        },
	        spacer = {
	        	type = 'header',
	        	name = ' ',
	        	order = 110,
	        },
	        settings = {
	        	type = 'group',
	        	order = 90,
	        	name = L["Settings"],
	        	desc = L["This needs work, I know"],
	        	args = {}
	        }
		}
	}
	
local function ToggleMenu(data)
	local func_Get,func_Set
	
	if (data.type == "toggle" or data.type == "range" or data.type == "text") then
		func_Get = function()
			if (data.reversed) then
				return not nQuestLog.db.profile[data.variable]
			end
			return nQuestLog.db.profile[data.variable]
		end
		func_Set = function(v)
			if (data.reversed) then
				v = not v
			end
			nQuestLog.db.profile[data.variable] = v
			nQuestLog:RefreshTracker()
			
			-- Custom stuff needed for only few things:
			if (data.variable == "width") then
				-- This refreshes width:
				nQuestLog:ToggleVisible(true)
			elseif (data.variable == "trackerGrowUp") then
				nQuestLog:SavePosition()
				nQuestLog:SetPosition()
			end
		end
	end
	
	return func_Get,func_Set	
end

local AceProfile = {
	positionBottom = -1,
	positionLeft = -1,
	positionTop = -1,
}
local settingsTable = {
	-- This table is only used to generate AceProfile and the menu to change it
	{ name=L["Main settings"], type="header", variable="MainHeader" },
	{ name=L["Lock minion"], type="toggle", desc=L["Lock the minion to avoid dragging (drag by pulling top left)"], variable="trackerLocked", value=false },
	
	{ name=L["Quest"], type="group" },
	{ name=L["Show new quests"], type="toggle", desc=L["Auto show new quests in minion"], variable="trackNewQuests", value=true },
	{ name=L["Show quest when looting questitem"], type="toggle", desc=L["Auto show hidden quests when you loot a quest item for it"], variable="trackWhenLooting", value=true },
	
	-- Quest objective tracking related
	{ name=L["Quest objectives"], type="group" },
	{ name=L["Hide All Objectives"], type="toggle", desc=L["Hide all quest objectives by default"], variable="hideAllObjectives", value=true },
	{ name=L["Hide Completed Objectives"], type="toggle", desc=L["Hide completed objectives"], variable="hideCompletedObjectives", value=true },
	

	{ name=L["Layouts"], type="header", variable="LayoutHeader",menuParent=options.args.settings.args  },
	
	-- Layout stuff:
		{ name=L["Minion layout"], type="group" },
		{ name=L["Grow upwards"], type="toggle", desc=L["Grow minion up"], variable="trackerGrowUp", value=false },
		{ name=L["Width"], type="range", desc=L["Set width of frame"], variable="width", value=266, min=50,max=500 },
		{ name=L["Fontsize"], type="range", desc=L["Change font size for minion"], variable="fontSize", value=13, min=1,max=25,step=1 },
	
		--Zone Related:
		{ name=L["Zone layout"], type="group" },
		{ name=L["Show Visible/Total quests for a zone"], type="toggle", desc=L["Shows <Zone> with X/X Visible"], variable="showZoneVisibleStatus", value=false },
		{ name=L["Show empty zones"], type="toggle", desc=L["Show hidden zones where you are not tracking any quests"], variable="showEmptyZones", value=true },
		{ name=L["Show Zone level"], type="toggle", desc=L["Show zone level"], variable="showZoneLevel", value=true },
		{ name=L["Fontsize"], type="range", desc=L["Change font size for zone"], variable="fontSizeZone", value=14, min=1,max=25,step=1 },
		{ name=L["Padding"], type="range", desc=L["Change padding between zones"], variable="zonePadding", value=0, min=0,max=10,step=1 },
		
		--Quest Related:
		{ name=L["Quest layout"], type="group" },
		{ name=L["Show Quest Progress"], type="toggle", desc=L["Show quest progress (1/7 items total)"], variable="showQuestProgress", value=true },
		{ name=L["Padding"], type="range", desc=L["Change padding between quests"], variable="questPadding", value=0, min=0,max=10,step=1 },
		
		--Quest objectives related:
		{ name=L["Quest objectives layout"], type="group" },
		{ name=L["Show Description when no objectives"], type="toggle", desc=L["Show small quest description when no progress is available"], variable="showShortWhenNoObjectives", value=true },
}
	
-- Make options menu for all settings:
local function MakeAllSettings()
	local menuParent = options.args.settings.args
	for i,data in ipairs(settingsTable) do
		local func_Get,func_Set = ToggleMenu(data)
	
		-- First add menu
		local strName = data.name
		if (data.type ~= "header") then
			strName = "  " .. strName
		end
		
		if (data.type == "group") then
			menuParent = options.args.settings.args
			data.desc = strName .. " settings"
			data.variable = data.name
			data.args = {}
		end
		
		if (data.menuParent) then
			menuParent = data.menuParent
		end
		
		menuParent[data.name] = {
	        type = data.type,
	        name = strName,
	        desc = data.desc, 
	        order = i,
	        get = func_Get,
	        set = func_Set,
	        min = data["min"],
	        max = data["max"],
	        step = data["step"],
	        isPercent = data["isPercent"],
	        validate = data["validate"],
	        args = data.args,
	        disabled = data.disabled,
		}
		
		if (data.type == "group") then
			menuParent = menuParent[data.variable].args
		end
		
		--Then add us to the RegisterDefaults db.
		AceProfile[data.variable] = data.value
	end
	
	settingsTable = nil
end

MakeAllSettings()


nQuestLog:RegisterDB("nQuestLogDB")
nQuestLog:RegisterDefaults('profile', AceProfile)

nQuestLog:RegisterDefaults('char', {
	visible = true,
	watchedQuests = {},
	watchedObjectives = {},
	hiddenZones = {},
})

nQuestLog.mainMenu = options
